OverviewWindow = class(Turbine.UI.Window);
 
function OverviewWindow:Constructor()

  Turbine.UI.Window.Constructor(self);
  local width = 700;
  local height = 90;
	self:SetSize(width,height);


  if (not data_loaded) then
		data.numbers.overview_x = Turbine.UI.Display:GetWidth()/2 - self:GetWidth()/2;
		data.numbers.overview_y = 0;
  end
	

	self:UpdatePosition();
  self:SetWantsKeyEvents(true);
  self:SetMouseVisible(false);

	self.bar_start = width/13 + 3;
	self.bar_end = width - width/13 - 3
	self.bar_length = self.bar_end - self.bar_start;
	
	self.empty_bar = Turbine.UI.Label();
	self.empty_bar:SetParent(self);
	self.empty_bar:SetSize(self.bar_length,18);
	self.empty_bar:SetPosition(self.bar_start+3,25);
	self.empty_bar:SetBackground("PvMP_Plus/Resources/Progress_Bar/bar_empty.tga");
	self.empty_bar:SetMouseVisible(false);
	
	self.filled_bar = Turbine.UI.Label();
	self.filled_bar:SetParent(self);
	self.filled_bar:SetPosition(self.bar_start+3,25);
	self.filled_bar:SetBackground("PvMP_Plus/Resources/Progress_Bar/bar_filled.tga");
	self.filled_bar:SetMouseVisible(false);
	self.filled_bar:SetVisible(true);
	
	self.percentage = Turbine.UI.Label();
	self.percentage:SetParent(self);
  self.percentage:SetSize(width,18);
  self.percentage:SetPosition(0,25);
  self.percentage:SetFont(Turbine.UI.Lotro.Font.Verdana12);
  self.percentage:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	self.percentage:SetMouseVisible(false);
		
	self.left_end = Turbine.UI.Label();
	self.left_end:SetParent(self);
	self.left_end:SetSize(6,18);
	self.left_end:SetPosition(self.bar_start-3,25);
	self.left_end:SetMouseVisible(false);
		
	self.right_end = Turbine.UI.Label();
	self.right_end:SetParent(self);
	self.right_end:SetSize(6,18);
	self.right_end:SetPosition(self.bar_end-3,25);
	self.right_end:SetMouseVisible(false);
  ------------------------------------------------------------
  self.label_points = Turbine.UI.Label();
  self.label_points:SetParent(self);
  self.label_points:SetSize(width,20);
  self.label_points:SetForeColor(Turbine.UI.Color(245/255,222/255,147/255));
	self.label_points:SetPosition(width/2-self.label_points:GetSize()/2,45);
	self.label_points:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
  self.label_points:SetFont(Turbine.UI.Lotro.Font.TrajanPro15);
	self.label_points:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.label_points:SetMouseVisible(false);
	------------------------------------------------------------
	self.label_day = Turbine.UI.Label();
  self.label_day:SetParent(self);
  self.label_day:SetSize(width/4,20);
  self.label_day:SetForeColor(Turbine.UI.Color(245/255,222/255,147/255));
	self.label_day:SetPosition(0,70);
	self.label_day:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
  self.label_day:SetFont(Turbine.UI.Lotro.Font.TrajanPro15);
	self.label_day:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.label_day:SetMouseVisible(false);
  ------------------------------------------------------------
	self.label_last_hour = Turbine.UI.Label();
  self.label_last_hour:SetParent(self);
  self.label_last_hour:SetSize(width/4,20);
  self.label_last_hour:SetForeColor(Turbine.UI.Color(245/255,222/255,147/255));
	self.label_last_hour:SetPosition(width/4,70);
	self.label_last_hour:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
  self.label_last_hour:SetFont(Turbine.UI.Lotro.Font.TrajanPro15);
	self.label_last_hour:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.label_last_hour:SetMouseVisible(false);
	------------------------------------------------------------
	self.label_10min = Turbine.UI.Label();
  self.label_10min:SetParent(self);
  self.label_10min:SetSize(width/4,20);
  self.label_10min:SetForeColor(Turbine.UI.Color(245/255,222/255,147/255));
	self.label_10min:SetPosition(2 * width/4,70);
	self.label_10min:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
  self.label_10min:SetFont(Turbine.UI.Lotro.Font.TrajanPro15);
	self.label_10min:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.label_10min:SetMouseVisible(false);
	------------------------------------------------------------
  self.label_last_fight = Turbine.UI.Label();
  self.label_last_fight:SetParent(self);
  self.label_last_fight:SetSize(width/4,20);
  self.label_last_fight:SetForeColor(Turbine.UI.Color(245/255,222/255,147/255));
	self.label_last_fight:SetPosition(3 * width/4,70);
	self.label_last_fight:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
  self.label_last_fight:SetFont(Turbine.UI.Lotro.Font.TrajanPro15);
	self.label_last_fight:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.label_last_fight:SetMouseVisible(false);
	------------------------------------------------------------
  self.label_commendations = Turbine.UI.Label();
  self.label_commendations:SetParent(self);
  self.label_commendations:SetSize(55,20);
  self.label_commendations:SetForeColor(Turbine.UI.Color(245/255,222/255,147/255));
	self.label_commendations:SetPosition(23/24 * width - self.label_commendations:GetSize()/2,48);
	self.label_commendations:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
  self.label_commendations:SetFont(Turbine.UI.Lotro.Font.TrajanPro15);
	self.label_commendations:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.label_commendations:SetMouseVisible(false);
  ------------------------------------------------------------
  self.pic_commendations = Turbine.UI.Label();
  self.pic_commendations:SetParent(self);
  self.pic_commendations:SetSize(32,32);
	self.pic_commendations:SetPosition(23/24 * width - self.pic_commendations:GetSize()/2,18);
	self.pic_commendations:SetBackground(0x41123495);
	self.pic_commendations:SetMouseVisible(false);
  ------------------------------------------------------------
	self.label_rank = Turbine.UI.Label();
  self.label_rank:SetParent(self);
  self.label_rank:SetSize(55,20);
  self.label_rank:SetForeColor(Turbine.UI.Color(245/255,222/255,147/255));
	self.label_rank:SetPosition(1/24 * width - self.label_rank:GetSize()/2,48);
	self.label_rank:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
  self.label_rank:SetFont(Turbine.UI.Lotro.Font.TrajanPro15);
	self.label_rank:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.label_rank:SetMouseVisible(false);
  ------------------------------------------------------------
  self.pic_rank = Turbine.UI.Label();
  self.pic_rank:SetParent(self);
  self.pic_rank:SetSize(32,32);
	self.pic_rank:SetPosition(1/24 * width - self.pic_rank:GetSize()/2,18);
	self.pic_rank:SetMouseVisible(false);
  ------------------------------------------------------------
	self.separator = Turbine.UI.Label();
  self.separator:SetParent(self);
  self.separator:SetSize(width,1);
	self.separator:SetPosition(0,70);
	self.separator:SetBackColor(Turbine.UI.Color(245/255,222/255,147/255));
	self.separator:SetMouseVisible(false);
	------------------------------------------------------------
  self.MovePanel = Turbine.UI.Control();
  self.MovePanel:SetParent(self);
  self.MovePanel:SetSize(1024,20);
  self.MovePanel:SetBackground(0x41007df9);
    
  self.MoveText = Turbine.UI.Label();
  self.MoveText:SetParent(self.MovePanel);
  self.MoveText:SetSize(width,12);
  self.MoveText:SetPosition(0,4);
  self.MoveText:SetFont(Turbine.UI.Lotro.Font.Verdana12);
  self.MoveText:SetText("PvMP+");
	self.MoveText:SetFontStyle(Turbine.UI.FontStyle.Outline);
  self.MoveText:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
  self.MoveText:SetMouseVisible(false);
  
	
	-- REPOSITIONING --
  -- shadow box
  self.shadowBox = Turbine.UI.Window();
  self.shadowBox:SetParent(self);
  self.shadowBox:SetPosition(0, 20);
	self.shadowBox:SetSize(width, height);
  self.shadowBox:SetMouseVisible(false);
  self.shadowBox:SetVisible(false);
	
	-- not used atm
  self.shadowBox.SizeChanged = function(sender, args)
      local width, height = sender:GetSize();
      self.topLeft:SetPosition(0, 0);
      self.top:SetPosition(10, 0);
      self.topRight:SetPosition(width - 10, 0);
      self.bottomLeft:SetPosition(0, height - 10);
      self.bottom:SetPosition(10, height - 10);
      self.bottomRight:SetPosition(width - 10, height - 10);
      self.left:SetPosition(0, 10);
      self.right:SetPosition(width - 10, 10);
        
      self.top:SetWidth(width - 20);
      self.bottom:SetWidth(width - 20);
      self.left:SetHeight(height - 20);
      self.right:SetHeight(height - 20);
  end
    
  -- top left corner
  self.topLeft = Turbine.UI.Control();
  self.topLeft:SetParent(self.shadowBox);
  self.topLeft:SetSize(10, 10);
  self.topLeft:SetMouseVisible(false);
  self.topLeft:SetBackground("PvMP_Plus/Resources/drag_topleft.tga");

  -- topRight
  self.topRight = Turbine.UI.Control();
  self.topRight:SetParent(self.shadowBox);
  self.topRight:SetSize(10, 10);
  self.topRight:SetMouseVisible(false);
  self.topRight:SetBackground("PvMP_Plus/Resources/drag_topright.tga");
    
  -- bottomLeft
  self.bottomLeft = Turbine.UI.Control();
  self.bottomLeft:SetParent(self.shadowBox);
  self.bottomLeft:SetSize(10, 10);
  self.bottomLeft:SetMouseVisible(false);
  self.bottomLeft:SetBackground("PvMP_Plus/Resources/drag_bottomleft.tga");

  -- bottomRight
  self.bottomRight = Turbine.UI.Control();
  self.bottomRight:SetParent(self.shadowBox);
  self.bottomRight:SetSize(10, 10);
  self.bottomRight:SetMouseVisible(false);
  self.bottomRight:SetBackground("PvMP_Plus/Resources/drag_bottomright.tga");

	-- top side
  self.top = Turbine.UI.Control();
  self.top:SetParent(self.shadowBox);
  self.top:SetSize(0, 10);
  self.top:SetMouseVisible(false);
  self.top:SetBackground("PvMP_Plus/Resources/drag_topmid.tga");

  -- left side
  self.left = Turbine.UI.Control();
  self.left:SetParent(self.shadowBox);
  self.left:SetSize(10, 0);
  self.left:SetMouseVisible(false);
  self.left:SetBackground("PvMP_Plus/Resources/drag_midleft.tga");

  -- right side
  self.right = Turbine.UI.Control();
  self.right:SetParent(self.shadowBox);
  self.right:SetSize(10, 0);
  self.right:SetMouseVisible(false);
  self.right:SetBackground("PvMP_Plus/Resources/drag_midright.tga");
    
  -- bottom side
  self.bottom = Turbine.UI.Control();
  self.bottom:SetParent(self.shadowBox);
  self.bottom:SetSize(0, 10);
  self.bottom:SetMouseVisible(false);
  self.bottom:SetBackground("PvMP_Plus/Resources/drag_bottommid.tga");
	
  self.MovePanel:SetVisible(false);
  
  self.Moving = false;

  self.MovePanel.MouseDown = function(sender,args)
    self.MoveX = args.X;
    self.MoveY = args.Y;
    self.Moving = true;
    self.MovePanel:SetBackground(0x41007dfa);
  end
    
  self.MovePanel.MouseUp = function(sender,args)
    self.Moving = false;
    self.MovePanel:SetBackground(0x41007df9);
  end
    
  self.MovePanel.MouseMove = function(sender,args)
    if self.Moving then
      local newLeft = self:GetLeft() - (self.MoveX - args.X);
      local newTop = self:GetTop() - (self.MoveY - args.Y);
      if newLeft < 0 then newLeft = 0 end;
      if newTop < 0 then newTop = 0 end;
      if newLeft > (Turbine.UI.Display.GetWidth() - self:GetWidth()) then
        newLeft = Turbine.UI.Display.GetWidth() - self:GetWidth() end;
      if newTop > (Turbine.UI.Display.GetHeight() - self:GetHeight()) then
        newTop = Turbine.UI.Display.GetHeight() - self:GetHeight() end;
      self:SetPosition(newLeft,newTop);
			changes_made = true;
    end
  end


	self.MovePanel.MouseEnter = function(sender,args)
		self.shadowBox:SetVisible(true);
	end
		
	self.MovePanel.MouseLeave = function(sender,args)
		self.shadowBox:SetVisible(false);
	end
		
  self.KeyDown = function(sender,args) 
    if (args.Action == Turbine.UI.Lotro.Action.ToggleHUD) then
      self:SetVisible(not self:IsVisible()); -- toggle visibility of Window
    elseif (args.Action == Turbine.UI.Lotro.Action.RepositionUI) then
      self.MovePanel:SetVisible(not self.MovePanel:IsVisible()); -- toggle visibility of MovePanel
    end
  end
	
end


function OverviewWindow:UpdateOverview(make_visible)

	if make_visible then
		self:SetVisible(true);
  end
	
	self.label_points:SetText(L.Overview_Points .. FormatPoints(data.numbers.points_total));
	self.label_day:SetText(L.Overview_Day .. FormatPoints(data.numbers.points_current_day));
	self.label_last_hour:SetText(L.Overview_Last_Hour.. FormatPoints(GetPointsLastHour()));
	self.label_10min:SetText(L.Overview_Last_10min .. FormatPoints(GetPointsLast10min()));
	self.label_last_fight:SetText(L.Overview_Last_Fight .. FormatPoints(points_last_fight));

	self.label_commendations:SetText(data.numbers.commendations);
	if data.numbers.commendations > 9000 then
		self.label_commendations:SetVisible(not self.label_commendations:IsVisible());
		self.pic_commendations:SetVisible(not self.pic_commendations:IsVisible());
		self.label_commendations:SetForeColor(Turbine.UI.Color(255/255,0/255,0/255));
	else
		self.label_commendations:SetVisible(true);
		self.pic_commendations:SetVisible(true);
		self.label_commendations:SetForeColor(Turbine.UI.Color(245/255,222/255,147/255));
	end
	
	for i=0, 14 do
		if (data.numbers.points_total >= Ranks[i] and data.numbers.points_total < Ranks[i+1]) then
			local rank_difference = Ranks[i+1] - Ranks[i];
			local points_since_rankup = data.numbers.points_total - Ranks[i];
			local percentage_done = points_since_rankup / rank_difference;
			self.pic_rank:SetBackground(Rank_Icons[i]);
			self.label_rank:SetText(L.Strings_Rank..i);
			self:UpdateProgressBar(percentage_done);
			return;
		end
	end
	self.pic_rank:SetBackground(Rank_Icons[15])
	self.label_rank:SetText(L.Strings_Rank.."15");
	self:UpdateProgressBar(1); -- Rank 15
end


function OverviewWindow:UpdateProgressBar(percentage_done)

	self.percentage:SetText(math.floor(percentage_done*10000)/100 .. "%");

	local filled_pixel = math.floor(self.bar_length * percentage_done);
	self.filled_bar:SetSize(filled_pixel,18);
	if (filled_pixel == self.bar_length) then
		self.left_end:SetBackground("PvMP_Plus/Resources/Progress_Bar/bar_end_left_4.tga");
		self.right_end:SetBackground("PvMP_Plus/Resources/Progress_Bar/bar_end_right_4.tga");
	elseif (filled_pixel == self.bar_length - 1) then
		self.left_end:SetBackground("PvMP_Plus/Resources/Progress_Bar/bar_end_left_4.tga");
		self.right_end:SetBackground("PvMP_Plus/Resources/Progress_Bar/bar_end_right_3.tga");
	elseif (filled_pixel == self.bar_length - 2) then
		self.left_end:SetBackground("PvMP_Plus/Resources/Progress_Bar/bar_end_left_4.tga");
		self.right_end:SetBackground("PvMP_Plus/Resources/Progress_Bar/bar_end_right_2.tga");
	elseif (filled_pixel == 2) then
		self.left_end:SetBackground("PvMP_Plus/Resources/Progress_Bar/bar_end_left_3.tga");
		self.right_end:SetBackground("PvMP_Plus/Resources/Progress_Bar/bar_end_right_1.tga");
	elseif (filled_pixel == 1) then
		self.left_end:SetBackground("PvMP_Plus/Resources/Progress_Bar/bar_end_left_2.tga");
		self.right_end:SetBackground("PvMP_Plus/Resources/Progress_Bar/bar_end_right_1.tga");
	elseif (filled_pixel == 0) then
		self.left_end:SetBackground("PvMP_Plus/Resources/Progress_Bar/bar_end_left_1.tga");
		self.right_end:SetBackground("PvMP_Plus/Resources/Progress_Bar/bar_end_right_1.tga");
	else
		self.left_end:SetBackground("PvMP_Plus/Resources/Progress_Bar/bar_end_left_4.tga");
		self.right_end:SetBackground("PvMP_Plus/Resources/Progress_Bar/bar_end_right_1.tga");
	end

	if (filled_pixel < self.bar_length-3) then
		self.filled_bar:SetSize(filled_pixel-3,18);
	else
		self.filled_bar:SetSize(self.bar_length-6,18);
	end
end

function OverviewWindow:UpdatePosition()
	self:SetPosition(data.numbers.overview_x,data.numbers.overview_y);
end


function OverviewWindow:ToggleStatsVisibility()

	local stats_visible = self.separator:IsVisible();
	
	self.separator:SetVisible(not stats_visible);
	self.label_day:SetVisible(not stats_visible);
	self.label_last_hour:SetVisible(not stats_visible);
	self.label_10min:SetVisible(not stats_visible);
	self.label_last_fight:SetVisible(not stats_visible);
	
end