Settings = class(Turbine.UI.Window);
 
function Settings:Constructor()

	local width = 200;
  local height = 180;
  local x = Turbine.UI.Display:GetWidth()/2 - width/2;
  local y = Turbine.UI.Display:GetHeight()/2 - height/2;

  Turbine.UI.Lotro.Window.Constructor(self);
  
  self:SetSize(width,height);
  self:SetPosition(x,y);
  self:SetText("PvMP+");
	------------------------------------------------------------
	self.update_button = Turbine.UI.Lotro.Button();
	self.update_button:SetText(L.Options_Update);
	self.update_button:SetSize(width - 40,30);
	self.update_button:SetPosition(width/2 - self.update_button:GetWidth()/2,50);
	self.update_button:SetParent(self);

	self.reset_button = Turbine.UI.Lotro.Button();
	self.reset_button:SetText(L.Options_Reset);
	self.reset_button:SetSize(width - 40,30);
	self.reset_button:SetPosition(width/2 - self.reset_button:GetWidth()/2,80);
	self.reset_button:SetParent(self);
	
	self.show_stats_checkbox = Turbine.UI.Lotro.CheckBox();
	self.show_stats_checkbox:SetParent(self);
	self.show_stats_checkbox:SetText("");
	self.show_stats_checkbox:SetPosition(width/2 - self.reset_button:GetWidth()/2 + 1,94);
	self.show_stats_checkbox:SetChecked(true);
	
	self.show_stats_label = Turbine.UI.Label();
	self.show_stats_label:SetText(L.Options_Show_Stats);
	self.show_stats_label:SetSize(width,30);
	self.show_stats_label:SetPosition(width/2 - self.reset_button:GetWidth()/2 + 23,104);
	self.show_stats_label:SetFont(Turbine.UI.Lotro.Font.TrajanPro14);
	self.show_stats_label:SetForeColor(Turbine.UI.Color(245/255,222/255,147/255));
	self.show_stats_label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	self.show_stats_label:SetParent(self);
	
	self.ok_button = Turbine.UI.Lotro.Button();
	self.ok_button:SetText("OK");
	self.ok_button:SetPosition(width/2 - self.ok_button:GetWidth()/2,135);
	self.ok_button:SetParent(self);
	
	
	self.show_stats_checkbox.CheckedChanged = function()
		overviewWindow:ToggleStatsVisibility();
	end
	
	self.update_button.MouseClick = function()
		initWindow:Open();
	end

	self.reset_button.MouseClick = function()
		data.numbers.overview_x = Turbine.UI.Display:GetWidth()/2 - overviewWindow:GetWidth()/2;
		data.numbers.overview_y = 0;
		overviewWindow:UpdatePosition();
	end
	
	self.ok_button.MouseClick = function()
		self:SetVisible(false);
	end
	
end

function Settings:Open()
	self:SetVisible(true);
end